<script>
import { GlIcon, GlTooltipDirective as GlTooltip } from "@gitlab/ui";
import languageMappings from "../../../../scripts/supported-code-languages.json";

export default {
  directives: {
    GlTooltip,
  },
  components: {
    GlIcon,
  },
  props: {
    codeContent: {
      type: String,
      required: true,
    },
    codeLanguage: {
      type: String,
      required: true,
    },
  },
  data() {
    return {
      copiedStatus: "",
    };
  },
  computed: {
    shouldShowLanguage() {
      return !this.codeLanguage.startsWith("plain");
    },
    displayLanguage() {
      if (!this.codeLanguage) return "";
      return languageMappings[this.codeLanguage] || this.codeLanguage;
    },
  },
  methods: {
    async copy() {
      // Hide the hover tooltip
      // https://bootstrap-vue.org/docs/directives/tooltip#hiding-and-showing-tooltips-via-root-events
      this.$root.$emit("bv::hide::tooltip");

      try {
        this.copiedStatus = "Copied!";
        await window.navigator.clipboard.writeText(this.codeContent);
        setTimeout(() => {
          // Hide the "Copied!" tooltip after 1.5s
          this.copiedStatus = "";
          this.$root.$emit("bv::hide::tooltip");
        }, 1500);
      } catch (err) {
        console.error("Failed to copy: ", err);
      }
    },
  },
};
</script>

<template>
  <div
    class="docs-codeblock-toolbar gl-flex gl-items-center gl-justify-between gl-bg-gray-100 gl-py-2 gl-pr-3"
  >
    <span class="gl-pl-5 gl-text-sm gl-flex" data-testid="code-lang">
      {{ shouldShowLanguage ? displayLanguage : "" }}
    </span>
    <span
      v-gl-tooltip.click
      :title="copiedStatus"
      class="gl-cursor-pointer gl-flex"
    >
      <gl-icon
        v-gl-tooltip.focus.hover
        name="copy-to-clipboard"
        aria-label="Copy to clipboard"
        class="clipboard-icon hover:gl-fill-purple-600 focus:gl-fill-purple-600 gl-transition-colors"
        tabindex="0"
        title="Copy"
        @click="copy()"
        @keydown.enter="copy()"
      />
      <span class="sr-only">Copy to clipboard</span>
      <span aria-live="polite" class="sr-only">
        {{ copiedStatus }}
      </span>
    </span>
  </div>
</template>
